-- Set SocialGuy Window Positions
-- sneeze, rich, tickle
local Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "SocialGuySettings");
local WindX,WindY=Turbine.UI.Display:GetWidth()/2-100,Turbine.UI.Display:GetHeight()/2-100;
if Settings~=nil then
	if Settings["WindPosX"]~=nil then WindX=Settings["WindPosX"] end
	if Settings["WindPosY"]~=nil then WindY=Settings["WindPosY"] end
end

-- Global Variables
version = "v2.10";
endQueue = false; -- flag to signal end of queue

-- Create Window
wSocialGuy = Turbine.UI.Lotro.Window();
wSocialGuy:SetSize(235,695);
wSocialGuy:SetPosition(WindX,WindY);
wSocialGuy:SetText("SocialGuy");
if Settings~=nil then
	wSocialGuy:SetVisible(Settings["WindState"])
end

-- Create Listbox & Scrollbar
listbox = Turbine.UI.ListBox();
listbox:SetParent(wSocialGuy);
listbox:SetBackColor( Turbine.UI.Color( 0.05, 0.05, 0.05 ) );
listbox:SetPosition( 20, 60 );
listbox:SetSize( 190, 380 );
listscroll = Turbine.UI.Lotro.ScrollBar();
listscroll:SetParent(listbox);
listscroll:SetOrientation(Turbine.UI.Orientation.Vertical);
listscroll:SetSize(12,listbox:GetHeight());
listscroll:SetPosition(listbox:GetWidth()-9,0);
listscroll:SetVisible(false);
listscroll:SetZOrder(200000);
listbox:SetVerticalScrollBar(listscroll);

-- Create Checkboxes & Emote Quickslots
checkbox = {};
emote = {};
emotebk = {};
emoteqs = {};
for k,v in pairs (_EMOTES) do
	local listitem = Turbine.UI.Control();
	listitem:SetSize(listbox:GetWidth(),20);

	-- Create Emote Button
	emote[k]=Turbine.UI.Label();
	emote[k]:SetParent(listitem);
	emote[k]:SetSize(15,15);
	emote[k]:SetPosition(1,1);
	emote[k]:SetBackground("RadicusPlugins/SocialGuy/Resources/Spk.tga");
	emote[k]:SetMouseVisible(false);

	emotebk[k]=Turbine.UI.Control();
	emotebk[k]:SetParent(listitem);
	emotebk[k]:SetSize(emote[k]:GetWidth(),emote[k]:GetHeight());
	emotebk[k]:SetPosition(emote[k]:GetLeft(),emote[k]:GetTop());
	emotebk[k]:SetZOrder(-1);

	emoteqs[k]=Turbine.UI.Lotro.Quickslot();
	emoteqs[k]:SetParent(emotebk[k]);
	emoteqs[k]:SetSize(emote[k]:GetWidth()+34,emote[k]:GetHeight()+34);
	emoteqs[k]:SetPosition(-34,-34);
	emoteqs[k]:SetAllowDrop(false);

	emoteqs[k].DragDrop=function(sender)
		local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
		sc:SetData(v);
		sender:SetShortcut(sc);
		Turbine.Shell.WriteLine(sc);
	end
	
	emoteqs[k]:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, v));
	emoteqs[k].AliasText=v;

	checkbox[k]=Turbine.UI.Lotro.CheckBox();
	checkbox[k]:SetParent(listitem);
	checkbox[k]:SetPosition(20,1);
	checkbox[k]:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	checkbox[k]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	checkbox[k]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	if k >=1 and k <= 11 then
		checkbox[k]:SetForeColor(Turbine.UI.Color(1,0,0)); -- display moods in red
	--	checkbox[k]:SetChecked(true);
	else
		if k >= 12 and k <=24  then
			checkbox[k]:SetForeColor(Turbine.UI.Color(0,1,1)); -- display social titles in blue
			-- checkbox[k]:SetChecked(true);
		else
			checkbox[k]:SetChecked(false);
			if k >= 25 and k <=28 then
				checkbox[k]:SetForeColor(Turbine.UI.Color(0,1,0)); -- display northern dailies in green
			else
				checkbox[k]:SetForeColor(Turbine.UI.Color(1,1,0)); -- the rest in yellow
			end
		end
	end
	checkbox[k]:SetText(" " .. v);
	checkbox[k]:SetSize(150,20);
	listbox:AddItem(listitem);
end

-- Create Labels To Center of Window (text, ypos)
function CreateLabel (t,y)
	labelCreate = Turbine.UI.Label();
	labelCreate:SetParent(wSocialGuy);
	labelCreate:SetText(t);
	labelCreate:SetSize(wSocialGuy:GetWidth(),20);
	labelCreate:SetPosition(wSocialGuy:GetWidth()/2-labelCreate:GetWidth()/2,y)
	labelCreate:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	labelCreate:SetForeColor(Turbine.UI.Color(1,1,0));
	labelCreate:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
end

-- Create Labels
CreateLabel("Red - Moods", wSocialGuy:GetHeight()-250);
CreateLabel("Blue - Social Titles", wSocialGuy:GetHeight()-235);
CreateLabel("Green - Northern Dailies", wSocialGuy:GetHeight()-220);
CreateLabel("Yellow - Standard Emotes", wSocialGuy:GetHeight()-205);
--CreateLabel("be sociable",wSocialGuy:GetHeight()-30);

-- Create Cycle Queue Button
wSocialGuy.QueueButton=Turbine.UI.Label();
wSocialGuy.QueueButton:SetParent(wSocialGuy);
wSocialGuy.QueueButton:SetSize(150, 20);
wSocialGuy.QueueButton:SetPosition(wSocialGuy:GetWidth()/2-wSocialGuy.QueueButton:GetWidth()/2,wSocialGuy:GetHeight()-105);
wSocialGuy.QueueButton:SetBackground("RadicusPlugins/SocialGuy/Resources/Queue.tga");
wSocialGuy.QueueButton:SetMouseVisible(false);

wSocialGuy.EmoteQSBack=Turbine.UI.Control();
wSocialGuy.EmoteQSBack:SetParent(wSocialGuy);
wSocialGuy.EmoteQSBack:SetSize(wSocialGuy.QueueButton:GetWidth(),wSocialGuy.QueueButton:GetHeight())
wSocialGuy.EmoteQSBack:SetPosition(wSocialGuy.QueueButton:GetLeft(),wSocialGuy.QueueButton:GetTop())
wSocialGuy.EmoteQSBack:SetZOrder(-1);

wSocialGuy.EmoteQS = Turbine.UI.Lotro.Quickslot();
wSocialGuy.EmoteQS:SetParent(wSocialGuy.EmoteQSBack);
wSocialGuy.EmoteQS:SetSize(wSocialGuy.QueueButton:GetWidth()+34,wSocialGuy.QueueButton:GetHeight()+20)
wSocialGuy.EmoteQS:SetPosition(0,-20);
wSocialGuy.EmoteQS:SetAllowDrop(false);

wSocialGuy.EmoteQS.DragDrop=function(sender)
	local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
	sc:SetData(currentEmote);
	sender:SetShortcut(sc);
	Turbine.Shell.WriteLine(sc);
end

-- Create Select All Button
wSocialGuy.CheckAllButton=Turbine.UI.Lotro.Button();
wSocialGuy.CheckAllButton:SetParent(wSocialGuy);
wSocialGuy.CheckAllButton:SetSize(150,30);
wSocialGuy.CheckAllButton:SetPosition(wSocialGuy:GetWidth()/2-wSocialGuy.CheckAllButton:GetWidth()/2,wSocialGuy:GetHeight()-180);
wSocialGuy.CheckAllButton:SetText("Select All");

wSocialGuy.CheckAllButton.MouseClick=function()
	for k,v in pairs (checkbox) do
		if checkbox[k]:IsChecked() == false then
			checkbox[k]:SetChecked(true);
		end
	end
	currentEmote=_EMOTES[1]; -- reset to first emote
	FindNextChecked(currentEmote); 
	SetEmote(currentEmote);
	Turbine.Shell.WriteLine("All emotes selected.");
end

-- Create Unselect All Button
wSocialGuy.UnCheckAllButton=Turbine.UI.Lotro.Button();
wSocialGuy.UnCheckAllButton:SetParent(wSocialGuy);
wSocialGuy.UnCheckAllButton:SetSize(150,30);
wSocialGuy.UnCheckAllButton:SetPosition(wSocialGuy:GetWidth()/2-wSocialGuy.UnCheckAllButton:GetWidth()/2,wSocialGuy:GetHeight()-155);
wSocialGuy.UnCheckAllButton:SetText("Unselect All");

wSocialGuy.UnCheckAllButton.MouseClick=function()
	for k,v in pairs (checkbox) do
		if checkbox[k]:IsChecked() == true then
			checkbox[k]:SetChecked(false);
		end
	end
	currentEmote=nil; 
	SetEmote(currentEmote); 
	Turbine.Shell.WriteLine("All emotes unselected.");
end

-- Create Reset Alias Button
wSocialGuy.ResetButton=Turbine.UI.Lotro.Button();
wSocialGuy.ResetButton:SetParent(wSocialGuy);
wSocialGuy.ResetButton:SetSize(150,30);
wSocialGuy.ResetButton:SetPosition(wSocialGuy:GetWidth()/2-wSocialGuy.ResetButton:GetWidth()/2,wSocialGuy:GetHeight()-130);
wSocialGuy.ResetButton:SetText("Clear & Reset Queue");

wSocialGuy.ResetButton.MouseClick=function()
	endQueue = false;
	currentEmote = nil;
	SetEmote(currentEmote); 
	currentEmote = FindNextChecked(currentEmote);
	Turbine.Shell.WriteLine("Emotes reset to first ticked item.");
end

-- Create Auto Loop Checkbox
wSocialGuy.CheckboxLoop = Turbine.UI.Lotro.CheckBox();
wSocialGuy.CheckboxLoop:SetPosition(wSocialGuy:GetWidth()/2-130/2,wSocialGuy:GetHeight()-85);
wSocialGuy.CheckboxLoop:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
wSocialGuy.CheckboxLoop:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
wSocialGuy.CheckboxLoop:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
wSocialGuy.CheckboxLoop:SetForeColor(Turbine.UI.Color(1,1,0));
wSocialGuy.CheckboxLoop:SetText(" " .. "Auto Loop Queue");
wSocialGuy.CheckboxLoop:SetParent(wSocialGuy);
wSocialGuy.CheckboxLoop:SetSize(150,30);
wSocialGuy.CheckboxLoop:SetChecked(false);

-- Create About Button
wSocialGuy.AboutButton=Turbine.UI.Lotro.Button();
wSocialGuy.AboutButton:SetParent(wSocialGuy);
wSocialGuy.AboutButton:SetSize(100,30);
wSocialGuy.AboutButton:SetPosition(wSocialGuy:GetWidth()/2-wSocialGuy.AboutButton:GetWidth()/2,wSocialGuy:GetHeight()-34);
wSocialGuy.AboutButton:SetText("About");
wSocialGuy.AboutButton.MouseClick=function()
--	wSocialGuy.About = Turbine.UI.Lotro.Window();
--	wSocialGuy.About:SetSize(450,200);
--	wSocialGuy.About:SetPosition(WindX+150,WindY+150);
--	wSocialGuy.About:SetText("About");
--	wSocialGuy.About:SetVisible()	
--
	Turbine.Shell.WriteLine("<rgb=#8888ff>SocialGuy " .. version .. " By Radicus Hood</rgb>");
	Turbine.Shell.WriteLine("<rgb=#fffffff>If you love this plugin, please make a donation to:");
	Turbine.Shell.WriteLine("<rgb=#888888>(PayPal) <rgb=#e9e230>paul@anotherworld.com.au</rgb> <rgb=#ffffff>or</rgb> <rgb=#888888>(BitCoin) <rgb=#e9e230>12PoPSt2VSabwD5VLwRrxzGfwVVkAr3m2b</rgb>");
end

-- Change Emote
function SetEmote(e)
	wSocialGuy.EmoteQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, e));
	wSocialGuy.EmoteQS.AliasText=e;
end

wSocialGuy.EmoteQS.MouseClick=function(sender,args)
	wSocialGuy.EmoteQS:SetWantsUpdates(true);
end

wSocialGuy.EmoteQS.Update=function(sender,args)
	sender:SetWantsUpdates(false);
	if endQueue == true then
		SetEmote(nil);
		Turbine.Shell.WriteLine("End of queue reached. Click reset queue.");
	else
		SetEmote(currentEmote);
		currentEmote = FindNextChecked(currentEmote);
	end		
end

-- Check if all unchecked
function AllUnchecked()
	local blALLUNCHECKED = true;
	for k,v in pairs (checkbox) do
		if checkbox[k]:IsChecked() == true then
			blALLUNCHECKED = false;
			break;
		end
	end
	return blALLUNCHECKED;
end

-- Find Next Checked Emote
function FindNextChecked(CURRENTEMOTE)
	if CURRENTEMOTE == nil then return _EMOTES[1] end;
	local NEXTEMOTE = CURRENTEMOTE;
	if AllUnchecked() == true then
		SetEmote(nil);
		Turbine.Shell.WriteLine("You must select at least one emote.");
	else
		local CURRENTEMOTEID = 1;
		local MAXEMOTES = 0;
		for k,v in pairs (_EMOTES) do
			if v == CURRENTEMOTE then CURRENTEMOTEID = k + 1 end;
			MAXEMOTES = MAXEMOTES + 1;
		end
		if CURRENTEMOTEID > MAXEMOTES then
			CURRENTEMOTEID = 1;
			if wSocialGuy.CheckboxLoop:IsChecked() == false then
				endQueue = true;
			end 
		end
		local loopThreshhold = 150; 
		local curLoop = 1;
		local blFOUNDCHECKBOX = false;
		while blFOUNDCHECKBOX == false and curLoop < loopThreshhold do
			if checkbox[CURRENTEMOTEID]:IsChecked() == true then
				NEXTEMOTE = _EMOTES[CURRENTEMOTEID];
				blFOUNDCHECKBOX = true;
				break;
			else
				if CURRENTEMOTEID >= MAXEMOTES then
					if wSocialGuy.CheckboxLoop:IsChecked() == true then
						CURRENTEMOTEID = 1;
					else
						endQueue = true;
						blFOUNDCHECKBOX = true;
						break;
					end
				else
					CURRENTEMOTEID = CURRENTEMOTEID + 1;
				end
			end
			curLoop = curLoop + 1;
		end
	end
	return NEXTEMOTE;
end

FindNextChecked(currentEmote);
SetEmote(currentEmote); 
